﻿Option Strict On
Option Explicit On

Imports System.DirectoryServices

Public Class frmMain

    Private strDataSource As String = "\\rs-win1\EDV\_IT-Log\changelog.xml"
    Private strLogoSource As String = "\\rs-win1\Ablage\Marketing Oeffentlich\Logos_NEU\farbig\RS-logo-new-01.jpg"

    Private Sub frmMain_Load(sender As Object, e As EventArgs) Handles Me.Load
        TB_Date.Text = Date.Now.ToShortDateString
        TB_User.Text = AccountManagement.UserPrincipal.Current.DisplayName
        Timer_Time.Start()
        PB_Logo.Image = Image.FromFile(strLogoSource)

        If System.IO.File.Exists(strDataSource) Then
            _dsIT_Log.ReadXml(strDataSource)
        Else
            MessageBox.Show("File (<" & strDataSource & ">) was deleted or removed.")
            Exit Sub
        End If
    End Sub

    Private Sub BT_SavePath_Click(sender As Object, e As EventArgs) Handles BT_SavePath.Click
        If SaveFileDialog.ShowDialog = DialogResult.OK Then TB_SavePath.Text = SaveFileDialog.FileName
    End Sub

    Sub Time(sender As Object, e As EventArgs) Handles Timer_Time.Tick
        TB_Time.Text = TimeString
    End Sub

    Sub ButtonAdd(sender As Object, e As EventArgs) Handles BT_ChangelogAdd.Click, BT_HardwareAdd.Click, BT_SoftwareAdd.Click, BT_GroupPolicyAdd.Click
        If sender Is BT_ChangelogAdd Then
            DtInfoBindingSource.AddNew()
            _dsIT_Log.WriteXml(strDataSource)
        ElseIf sender Is BT_HardwareAdd Then
            DtHardwareBindingSource.AddNew()
            _dsIT_Log.WriteXml(strDataSource)
        ElseIf sender Is BT_SoftwareAdd Then
            DtSoftwareBindingSource.AddNew()
            _dsIT_Log.WriteXml(strDataSource)
        ElseIf sender Is BT_GroupPolicyAdd Then
            DtGroupPolicyBindingSource.AddNew()
            _dsIT_Log.WriteXml(strDataSource)
        End If
    End Sub

    Sub ButtonSave(sender As Object, e As EventArgs) Handles BT_ChangelogSave.Click, BT_HardwareSave.Click, BT_SoftwareSave.Click, BT_GroupPolicySave.Click
        If sender Is BT_ChangelogSave Then
            DtInfoBindingSource.EndEdit()
            _dsIT_Log.WriteXml(strDataSource)
            DGV_Changelog.Sort(DGV_Changelog.Columns(0), System.ComponentModel.ListSortDirection.Ascending)
        ElseIf sender Is BT_HardwareSave Then
            DtHardwareBindingSource.EndEdit()
            _dsIT_Log.WriteXml(strDataSource)
            DGV_Hardware.Sort(DGV_Hardware.Columns(0), System.ComponentModel.ListSortDirection.Ascending)
        ElseIf sender Is BT_SoftwareSave Then
            DtSoftwareBindingSource.EndEdit()
            _dsIT_Log.WriteXml(strDataSource)
            DGV_Software.Sort(DGV_Software.Columns(0), System.ComponentModel.ListSortDirection.Ascending)
        ElseIf sender Is BT_GroupPolicySave Then
            DtGroupPolicyBindingSource.EndEdit()
            _dsIT_Log.WriteXml(strDataSource)
            DGV_GroupPolicy.Sort(DGV_GroupPolicy.Columns(0), System.ComponentModel.ListSortDirection.Ascending)
        End If
    End Sub

    Sub ButtonDelete(sender As Object, e As EventArgs) Handles BT_ChangelogDelete.Click, BT_HardwareDelete.Click, BT_SoftwareDelete.Click, BT_GroupPolicyDelete.Click
        If sender Is BT_ChangelogAdd Then
            DtInfoBindingSource.RemoveCurrent()
            _dsIT_Log.WriteXml(strDataSource)
        ElseIf sender Is BT_HardwareAdd Then
            DtHardwareBindingSource.RemoveCurrent()
            _dsIT_Log.WriteXml(strDataSource)
        ElseIf sender Is BT_SoftwareAdd Then
            DtSoftwareBindingSource.RemoveCurrent()
            _dsIT_Log.WriteXml(strDataSource)
        ElseIf sender Is BT_GroupPolicyDelete Then
            DtGroupPolicyBindingSource.RemoveCurrent()
            _dsIT_Log.WriteXml(strDataSource)
        End If
    End Sub

End Class